% Copyright 2018. ϴб ´ all rights reserved.
%  α׷  (ö ؼ  )θ ֽñ ٶ,
%    α׷ ʿ  ϰ ڵ带  , , ,   (۱ǹ) Դϴ. 
%%
clear; clc; close all;
rng('default');
delete(fullfile(pwd, 'Result', '*.*'))

time = tic;
%% 1. Data 

optimization_method = 2;                                                    % ȭ  (Maximize : 1 ,  Minimize : 2)
selection_operator = 3;                                                     % ȭ  (Roulette Wheel : 1 ,  Tournament : 2 ,  Gradient-like : 3)
pop_size = 30;                                                              %   10, 20, 30 (30 fix)
range_vars = [0.8, 6; 1, 1];                                               %  ź   0.8 ~ 3,  ź   1 ~ 1 ǹ
             

FinalResult = zeros(108,size(range_vars,1)+1); 
intNumbering = 0;
%% 2.ݺȽ  (0.1:0.1:0.9(9)/0.01,0.05.0.1/0:1:3)
for ii = 0.1:0.1:0.9
    for jj = [0.01 0.05 0.1]
        for kk = 0:1:3
           %%
            intNumbering = intNumbering+1;
            
           %%
            total_chrom_length = length(range_vars);
            crossover_prob = ii;                                                       
            mutation_prob = jj;                                                        
            max_generation = 1000;                                                      
            penalty_coeff = 500;
            digit_number = 3;                      
            step_mg = 10^(-kk);                                                          
            Result = zeros(max_generation,total_chrom_length+1);

            progress = waitbar(0,'Initializing...','Name','Please wait...');

            %Input Data of Structural /   ҷ (Import of Measured Displacement)
            [NODE, ELEMENT, MATERIAL, SECTION, CONSTRAINT, SPRING, CONLOAD, freq_m, modeshape_m] = InputStructureData('Railbridge_information.txt'); %   .txtϸ Է

            %ʱ   (Generation of Initial Population, ramdomly)
            old_pop = generation(pop_size, total_chrom_length, range_vars, digit_number);

            %յ  (Evaluation of the Fitness)
            [old_obj, old_fit] = fitness(old_pop, pop_size, optimization_method, penalty_coeff,...
                                         freq_m, modeshape_m, 1, NODE, ELEMENT, MATERIAL, SECTION, CONSTRAINT, SPRING);

            for n = 1:max_generation

                % (Selection)
                cross_pool = selection(old_pop, old_fit, pop_size, total_chrom_length, range_vars,...
                                       selection_operator);

                % (Crossover)
                mutation_pool = crossover(cross_pool, pop_size, total_chrom_length, range_vars,...
                                          crossover_prob, max_generation, step_mg, n);

                % (Mutation)
                elite_pool = mutation(mutation_pool, pop_size, total_chrom_length, range_vars,...
                                      mutation_prob, max_generation, digit_number, step_mg, n);

                %յ  (Evaluation of the Fitness)
                [new_obj, new_fit] = fitness(elite_pool, pop_size, optimization_method, penalty_coeff,...
                                             freq_m, modeshape_m, n, NODE, ELEMENT, MATERIAL, SECTION, CONSTRAINT, SPRING);

                %Ʈ  (Elitism)
                [new_pop, new_obj, new_fit] = elite(old_pop, old_obj, old_fit, elite_pool, new_obj, new_fit);

                %  (Print of the Result)
                [Result(n,:), old_pop, old_obj, old_fit] = result(new_pop, new_obj, new_fit);

                waitbar(n/max_generation, progress, sprintf('%d / %d Gen. (%.2f%%)  Complete', n,...
                        max_generation, n/max_generation*100))

            end

            close(progress)

            toc(time)
          
            FinalResult(intNumbering,:) = Result(max_generation,:);
        end
    end
end

%  (Save of Results)
FinalResult = array2table(FinalResult);
writetable(FinalResult,'FinalResult.xlsx');                                 %   (ź x   =  ź)
