function [dblModeShape, dblNatFreq] = PlateFrame_Dynamic(pop, pop_size, dblNode, intElmt, dblMtrl, dblSect, intCons, intSpring)
%% Basic Setting

intNDof = 6;                                                                
intNumNode = size(dblNode,1);                                               
intGDof = intNDof*intNumNode;                                               
matGlobalK = zeros(intGDof,intGDof);                                        
EigNum = 1;                                                                
ModeNum = 3;                                                               
dblNatFreq = zeros(pop_size,EigNum); 
dblModeShape = zeros(ModeNum, EigNum, pop_size);
zzz = zeros(ModeNum,EigNum);


%% Boundary Condition

matBound = zeros(intGDof,1);
intBLOOP = size(intCons,1);

for i = 1:intBLOOP
    matBound(intCons(i,1)*6-5:intCons(i,1)*6,1) = intCons(i,2:7)';
end


%% GA
for popi = 1:pop_size
    IniMtrl =[27468000;210000000];             % ö ź [, ] Էºκ
    popSpringNumbering =  size(IniMtrl,1);
    dblMtrl(1:popSpringNumbering,2) = pop(popi,1: popSpringNumbering)'.*IniMtrl; 
    
    %Boundary 
    intTScnNum = size(intSpring,1);
    
        
    for i=1:intTScnNum
        for j=1:intNDof
            if intSpring(i,1+j) == 0
                %popSpringNumbering = 1 + popSpringNumbering;
                matGlobalK((intSpring(i,1)-1)*intNDof+j,(intSpring(i,1)-1)*intNDof+j) = ...
                matGlobalK((intSpring(i,1)-1)*intNDof+j,(intSpring(i,1)-1)*intNDof+j)+1;
            end
        end
    end
    
    %% Mass & Stiffness Matrix
    [matGlobalK, matGlobalM] = Plate_K_M_mat(dblNode, intElmt, dblMtrl, dblSect);
    
    
    %% Remove Zero & Boundary Index

    % Boundary Index
    matTIndex = matBound;

    B = matGlobalK.^2;
    B = sum(B,2);

    %Zero Index
    for i = 1:intGDof
        if B(i,1) == 0
            matTIndex(i) = 1;
        end
    end

    %Using Index
    matTIndex = find(matTIndex==0);
    
    %% Result_Frequency / ModeShape

    %Eigen Vector_Subspace Iteration
    matDynGlbK = matGlobalK(matTIndex,matTIndex);
    matDynGlbM = matGlobalM(matTIndex,matTIndex);
           
    [matEigvector,matEigVal]=eigs(matDynGlbK,matDynGlbM,EigNum,'sm');
    dblNatFreq(popi,:) = sqrt(diag(matEigVal(1:EigNum,1:EigNum)))/2/pi;
    for i = 1:EigNum
        zzz(:,i) = [matEigvector(291,i); matEigvector(351,i); matEigvector(411,i)]; 
    end

     
    dblModeShape(:,:,popi) = zzz(:,:);

end   
end
    
    
    
    
    
    