function [obj_value, fit_value] = fitness(pop, pop_size, optimization_method, penalty_coeff,... 
                                          freq_m, modeshape_m, itr, NODE, ELEMENT, MATERIAL, SECTION, CONSTRAINT, SPRING)

    obj_value = zeros(pop_size,1);
    pnt_value = zeros(pop_size,1);
    fit_value = zeros(pop_size,1);
    
    %SAP2000 ؼ  (Arrangement of Analysis Result)
    [dblModeShape, freq] = PlateFrame_Dynamic(pop, pop_size, NODE, ELEMENT, MATERIAL, SECTION, CONSTRAINT, SPRING);
    
    ms1 = modeshape_m(:,1)/sqrt(modeshape_m(:,1)'*modeshape_m(:,1));        % 1   
    
    for i = 1:pop_size
        
        as1 = dblModeShape(:,1)/sqrt(dblModeShape(:,1)'*dblModeShape(:,1));     % 1  

        
        % Լ (Objective Function)
        obj_value(i) = sum(((freq_m(1,:)-freq(i,:))./freq_m(1,:)))+(sqrt((ms1-as1)'*(ms1-as1))/sqrt(ms1'*ms1)) ; 

        
        %Ģ Լ (Penalty Function)
        pnt_value(i) = (max(sum((freq_m(1,:)-freq(i,:)))./sum(freq_m(1,:))-0.01,0)) +...
                       (max((sqrt((ms1-as1)'*(ms1-as1))/sqrt(ms1'*ms1))-0.01,0)); 
    end
    
    switch optimization_method
        case 1
            fit_value = obj_value-(penalty_coeff*itr)^2*pnt_value;
        case 2
            fit_value = 1./(obj_value+(penalty_coeff*itr)^2*pnt_value);
    end
    
end